; DESASM.ASM { Hilfroutinen fr TRDES }

.MODEL small, PASCAL

LOCALS @@ ; Prfix fr lokale Labels

.486


.CODE



detect_cpu PROC NEAR
; stellt den cpu-Type fest: 286, 386 oder 486
; Ergebnis steht (Pascalkonform) im ax-Register
PUBLIC detect_cpu
cpu86  = 086
cpu186 = 186
cpu286 = 286
cpu386 = 386
cpu486 = 486

        push    bp              ; We MUST save bp for initialization code...

        mov     ax,CPU86        ; Default to 8086/8088 processor
        push    sp
        pop     bx              ; BX holds the value of SP or SP-2
        cmp     bx,sp           ; 88/86/186 pushes the value of SP-2
        je      @@Check286      ; Must be a 286/386/486 type processor
        mov     cl,32           ; 186 uses count mod 32 = 0
        shl     bx,cl           ; 86 shifts 32 bits left so ax = 0
        jz      @@Done          ; zero: shifted out all bits so 86/88
        mov     ax,CPU186       ; nonzero: no shift, so 186
        jz      @@Done

@@Check286:                     ; First check for 386/486 in 32 bit mode
        pushf                   ; Test for 16 or 32 operand size:
        mov     bx,sp           ;  pushed 2 or 4 bytes of flags
        popf
        inc     bx
        inc     bx
        cmp     bx,sp           ; did pushf change sp by 2?
        jnz     @@Check486      ; 32 bit push, so it is a 386/486

        sub     sp,6            ; Is it a 286/386/486 in 16 bit mode?
        mov     bp,sp
.486P ; Systembefehle zulassen
        sgdt    [QWORD ptr bp]  ; 80286/386/486 specific instrucion
.486  ; nur normale Befehle zulassen
        add     sp,4            ; Get global descriptor table
        pop     bx
        inc     bh              ; Third word of GDT = -1 for 286
        jnz     @@Check486      ; We have a 386/486

        mov     ax,CPU286       ; We have a 286
        jmp     @@done

@@Check486:

; Distinguish an 80386 from an 80486. Bit 18 (40000H) of EFLAGS register
; is used only in the 486. This code flips it and tests if anything happened.

        mov     edx,esp         ; Save stack pointer
        and     esp,not 3       ; Align stack pointer to prevent a fault
                                ;  when we set the AC flag on a 486
        pushfd                  ; Copy the EFLAGS register
        pop     eax             ;   into register eax
        mov     ecx,eax         ; Save the original EFLAGS value
        xor     eax,40000H      ; Flip the AC flag bit
        push    eax             ; Try to put the modified value back
        popfd                   ;   into the EFLAGS register
        pushfd                  ; Copy the EFLAGS register again
        pop     eax             ;   into eax
        xor     eax,ecx         ; Compare the old and new AC bits
        shr     eax,18          ; Shift and mask to get the AC comparison bit
        and     eax,1           ;   in the low order position of eax
        push    ecx
        popfd                   ; Restore EFLAGS that were saved on entry
        mov     esp,edx         ; And restore stack pointer to saved value
        mov     bx,ax           ; and move into bx

; At this point ax = 0 for a 386, or ax = 1 for a 486

        mov     ax,CPU386       ; Assume a 386
        test    bx,bx
        jz      @@done          ; We have a 386
        mov     ax,CPU486       ; We have a 486

@@Done:
        pop     bp              ; Restore bp
        ret                     ; We are done

ENDP detect_cpu


tLRBlock=32; { SizeOf(tLRBlock) }


DATA SEGMENT PUBLIC USE16
B48 DB 48 DUP (?)
B = B48
merk DB 48 DUP (?)
DATA ENDS


;  var B48 : array [1..48] of boolean;
;  B : array [1..8,1..6] of boolean absolute B48;
;  merk : tLRBlock;


zauber486 PROC NEAR LR : word, n : byte, RES : word, XOR_Displacement : word
PUBLIC zauber486
; procedure zauber486 (LR : ShorstPointer; n : byte; RES : ShortPointer; XOR_Displacement : word);
; { die ShortPointer sind Offsetadressen fr das Stacksegment }
;    sondern wir erwarten einen Zeiger auf das Original! }
EXTRN z_EXPAND : UNKNOWN ; in Pascal definiertes Feld (Expansionstabelle 32->48)
EXTRN z_PERM   : UNKNOWN ; in Pascal definiertes Feld (Permutationstabelle)
EXTRN z_S      : UNKNOWN ; in Pascal definiertes Feld (Bitvertauschungs-Indextabelle)
EXTRN K        : UNKNOWN ; in Pascal definiertes Feld (Schlsselpermutationen)
  push ds; { Datensegment merken }
;  { for i:=1 to 48 do B48[i]:=LR[expand[i]] xor K[n][i]; }
;  { dies wird nun realisiert }

  mov ax,SEG b48; { Segmentadressen von B48 (=:B) und MERK sind identisch }
  mov gs,ax; { nach gs }

  mov ax,SEG z_expand; { Segmentadressen von z_Expand, Z_Perm und z_S nach ds }
  mov ds,ax; { SEGMENT-Adresse der expand-Tabelle nach ds }
;          { Key-Tabelle liegt im gleichen Segment! }
  mov al,n;
  dec al; { Zeilenadresse der Key-Tabelle }
  mov ah,48;
  mul ah; { mit Anzahl Spalten multiplizieren }
  movzx ecx,ax; { OFFSET-Adresse der gewschten Teiltabelle von K nach cx, Hi-Word mit Nullen fllen }
  add cx,OFFSET K;
  mov di,LR; { Adresse der LR-Tabelle ist ss:di }
  mov bx,cx;
  xor bl,bl;
  sub di,bx; { um die Registertauschoperationen zu minimieren, subtrahieren wir bh von di }
  push bp;
  mov bp,OFFSET B48; { B48-Tabelle nach gs:bp }
  xor esi,esi; { Hi-Word si lschen }
  mov si,48-4; { Schleifenindex-Zhler initialisieren (48 Elemente abwrts bis negativ)  }
 @@Schleife1:
  mov edx,ds:[OFFSET z_expand + si]; { zwei Indices auf LR-Tabelle aus expand-Tabelle holen }
;  { Index ist aber bzgl. 1-orientiertem Array, also um 1 zu hoch! }
  mov bl,dl;
  mov al,ss:[di+bx-1]; { ersten Wert aus LR-Tabelle lesen }
  mov bl,dh;
  mov ah,ss:[di+bx-1]; { zweiten Wert aus LR-Tabelle lesen }
  bswap edx; { Hi-Word nach Lo-Word }
  bswap eax;
  mov bl,dl;
  mov al,ss:[di+bx-1]; { dritten Wert aus LR-Tabelle lesen }
  mov bl,dh;
  mov ah,ss:[di+bx-1]; { vierten Wert aus LR-Tabelle lesen }
  bswap eax;
  xor eax,ds:[ecx+esi]; { und XOR mit Eintrag K[n][si+1] bis K[n][si+4] aus dieser Tabelle }
  mov gs:[bp+si],eax; { und die vier Werte in die B48-Tabelle eintragen }
  sub si,4;
  jae @@Schleife1; { fertig, wenn si negativ }
  pop bp;

  mov si,OFFSET B; { OFFSET-Adresse von B[1,1] }
  mov di,OFFSET MERK
  xor cx,cx; { cx =:64*pred(i) und i zhlt von 1. Zeile bis 8. Zeile }
 @@MainLoop:
;  { aus B[i,1..6] folgende 6-Bit-Zahl erzeugen:
;    B[i,2],B[i,3],B[i,4],B[i,5],B[i,1],B[i,6] }
   xor bx,bx;
   mov bh,gs:[si+3-1];
   shr bx,1;
   mov bh,gs:[si+4-1];
   shr bx,1;
   mov bh,gs:[si+5-1];
   shr bx,1;
   mov bh,gs:[si+1-1];
   shr bx,1;
   mov bh,gs:[si+6-1];
   shr bx,3;
   or bl,gs:[si+2-1]; { nun steht der vollstndige 6-Bit-Wert in bx }
   add si,6; { Offset auf die nchste Zeile setzen }
;   { in bx steht nun das Spaltendisplacement }
   add bx,cx; { Displacement fr Zeile addieren }
   mov al,ds:[OFFSET z_S +bx]; { Wert holen }
;   { x=al:=S[i,x,y];} { dies ist der aktuelle Wert von x }
;   { Adresse von Merk[4*pred(i)+1] steht in [ss:di] }
;   { x in boolesche Binrdarstellung nach (Merk[4*(i-1)+1],..,Merk[4*(i-1)+4]) wandeln }
   mov ah,al;
   shr ah,1; { kopieren Wert um 1 geschifet nach ah }
;   { Nun das Nibble in booleschen Wert konvertieren }
   mov bx,ax;
   and bx,0101h; { zwei boolesche Werte holen und maskieren }
   shr ax,2; { jetzt mssen wir dafr allerdings um 2 Bits shiften ;-) }
   and ax,0101h; { boolesche Werte maskieren }
   mov gs:[di],bx;
   mov gs:[di][2],ax;
   add di,4; { und wegpppeln, 2 am Stck }

   add cx,64;
   cmp cx,7*64;
   jbe @@mainloop;

;  { for i:=1 to 32 do RES[i]:=MERK[z_perm[i]]; }
  xor ecx,ecx; { insbesondere Hi-Word von ecx lschen }
  mov cx,RES; { Adresse der RES-Tabelle ist ss:ecx }
  mov di,cx;
  add di,XOR_Displacement; { Adresse der XOR-Tabelle ist ss:di }
  mov si,OFFSET merk; { Adresse der MERK-Tabelle holen }
  push bp;
  mov ebp,32-4; { Index auf Null setzen, 32 Werte sind einzutragen }
  xor bh,bh; { Displacement Hi-Byte lschen }
 @@ResSchleife:
  mov edx,ds:[OFFSET z_perm +bp]; { zwei z_Perm-Indices holen }
;  { nicht vergessen: Array ist 1-orientiert [1..32], also 1 abziehen }
  mov bl,dl;
  mov al,gs:[si+bx-1]; { 1. indizierten Wert holen }
  mov bl,dh;
  mov ah,gs:[si+bx-1]; { 2. indizierten Wert holen }
  bswap eax
  bswap edx
  mov bl,dl;
  mov al,gs:[si+bx-1]; { 3. indizierten Wert holen }
  mov bl,dh;
  mov ah,gs:[si+bx-1]; { 4. indizierten Wert holen }
  bswap eax
  xor eax,ss:[bp+di]; { komponentenweises XOR mit durch Displacement gegebener Tabelle }
  mov ss:[ebp+ecx],eax; { und in RES-Tabelle eintragen }
  sub bp,4;
  jae @@ResSchleife; { solange bp nichtnegativ -> Schleife ausfhren }
  pop bp;
  pop ds; { Datensegment zurckholen }
  ret
ENDP zauber486



.386
; fr den 386er gleiche Routine wie oben, aber:
; bswap REGISTER wird durch ror REGISTER,16 ersetzt

zauber386 PROC NEAR LR : word, n : byte, RES : word, XOR_Displacement : word
PUBLIC zauber386
; procedure zauber486 (LR : ShorstPointer; n : byte; RES : ShortPointer; XOR_Displacement : word);
; { die ShortPointer sind Offsetadressen fr das Stacksegment }
;    sondern wir erwarten einen Zeiger auf das Original! }
EXTRN z_EXPAND : UNKNOWN ; in Pascal definiertes Feld (Expansionstabelle 32->48)
EXTRN z_PERM   : UNKNOWN ; in Pascal definiertes Feld (Permutationstabelle)
EXTRN z_S      : UNKNOWN ; in Pascal definiertes Feld (Bitvertauschungs-Indextabelle)
EXTRN K        : UNKNOWN ; in Pascal definiertes Feld (Schlsselpermutationen)
  push ds; { Datensegment merken }
;  { for i:=1 to 48 do B48[i]:=LR[expand[i]] xor K[n][i]; }
;  { dies wird nun realisiert }

  mov ax,SEG b48; { Segmentadressen von B48 (=:B) und MERK sind identisch }
  mov gs,ax; { nach gs }

  mov ax,SEG z_expand; { Segmentadressen von z_Expand, Z_Perm und z_S nach ds }
  mov ds,ax; { SEGMENT-Adresse der expand-Tabelle nach ds }
;          { Key-Tabelle liegt im gleichen Segment! }
  mov al,n;
  dec al; { Zeilenadresse der Key-Tabelle }
  mov ah,48;
  mul ah; { mit Anzahl Spalten multiplizieren }
  movzx ecx,ax; { OFFSET-Adresse der gewschten Teiltabelle von K nach cx, Hi-Word mit Nullen fllen }
  add cx,OFFSET K;
  mov di,LR; { Adresse der LR-Tabelle ist ss:di }
  mov bx,cx;
  xor bl,bl;
  sub di,bx; { um die Registertauschoperationen zu minimieren, subtrahieren wir bh von di }
  push bp;
  mov bp,OFFSET B48; { B48-Tabelle nach gs:bp }
  xor esi,esi; { Hi-Word si lschen }
  mov si,48-4; { Schleifenindex-Zhler initialisieren (48 Elemente abwrts bis negativ)  }
 @@Schleife1:
  mov edx,ds:[OFFSET z_expand + si]; { zwei Indices auf LR-Tabelle aus expand-Tabelle holen }
;  { Index ist aber bzgl. 1-orientiertem Array, also um 1 zu hoch! }
  mov bl,dl;
  mov al,ss:[di+bx-1]; { ersten Wert aus LR-Tabelle lesen }
  mov bl,dh;
  mov ah,ss:[di+bx-1]; { zweiten Wert aus LR-Tabelle lesen }
  ror edx,16; { Hi-Word nach Lo-Word }
  ror eax,16;
  mov bl,dl;
  mov al,ss:[di+bx-1]; { dritten Wert aus LR-Tabelle lesen }
  mov bl,dh;
  mov ah,ss:[di+bx-1]; { vierten Wert aus LR-Tabelle lesen }
  ror eax,16;
  xor eax,ds:[ecx+esi]; { und XOR mit Eintrag K[n][si+1] bis K[n][si+4] aus dieser Tabelle }
  mov gs:[bp+si],eax; { und die vier Werte in die B48-Tabelle eintragen }
  sub si,4;
  jae @@Schleife1; { fertig, wenn si negativ }
  pop bp;

  mov si,OFFSET B; { OFFSET-Adresse von B[1,1] }
  mov di,OFFSET MERK
  xor cx,cx; { cx =:64*pred(i) und i zhlt von 1. Zeile bis 8. Zeile }
 @@MainLoop:
;  { aus B[i,1..6] folgende 6-Bit-Zahl erzeugen:
;    B[i,2],B[i,3],B[i,4],B[i,5],B[i,1],B[i,6] }
   xor bx,bx;
   mov bh,gs:[si+3-1];
   shr bx,1;
   mov bh,gs:[si+4-1];
   shr bx,1;
   mov bh,gs:[si+5-1];
   shr bx,1;
   mov bh,gs:[si+1-1];
   shr bx,1;
   mov bh,gs:[si+6-1];
   shr bx,3;
   or bl,gs:[si+2-1]; { nun steht der vollstndige 6-Bit-Wert in bx }
   add si,6; { Offset auf die nchste Zeile setzen }
;   { in bx steht nun das Spaltendisplacement }
   add bx,cx; { Displacement fr Zeile addieren }
   mov al,ds:[OFFSET z_S +bx]; { Wert holen }
;   { x=al:=S[i,x,y];} { dies ist der aktuelle Wert von x }
;   { Adresse von Merk[4*pred(i)+1] steht in [ss:di] }
;   { x in boolesche Binrdarstellung nach (Merk[4*(i-1)+1],..,Merk[4*(i-1)+4]) wandeln }
   mov ah,al;
   shr ah,1; { kopieren Wert um 1 geschifet nach ah }
;   { Nun das Nibble in booleschen Wert konvertieren }
   mov bx,ax;
   and bx,0101h; { zwei boolesche Werte holen und maskieren }
   shr ax,2; { jetzt mssen wir dafr allerdings um 2 Bits shiften ;-) }
   and ax,0101h; { boolesche Werte maskieren }
   mov gs:[di],bx;
   mov gs:[di][2],ax;
   add di,4; { und wegpppeln, 2 am Stck }

   add cx,64;
   cmp cx,7*64;
   jbe @@mainloop;

;  { for i:=1 to 32 do RES[i]:=MERK[z_perm[i]]; }
  xor ecx,ecx; { insbesondere Hi-Word von ecx lschen }
  mov cx,RES; { Adresse der RES-Tabelle ist ss:ecx }
  mov di,cx;
  add di,XOR_Displacement; { Adresse der XOR-Tabelle ist ss:di }
  mov si,OFFSET merk; { Adresse der MERK-Tabelle holen }
  push bp;
  mov ebp,32-4; { Index auf Null setzen, 32 Werte sind einzutragen }
  xor bh,bh; { Displacement Hi-Byte lschen }
 @@ResSchleife:
  mov edx,ds:[OFFSET z_perm +bp]; { zwei z_Perm-Indices holen }
;  { nicht vergessen: Array ist 1-orientiert [1..32], also 1 abziehen }
  mov bl,dl;
  mov al,gs:[si+bx-1]; { 1. indizierten Wert holen }
  mov bl,dh;
  mov ah,gs:[si+bx-1]; { 2. indizierten Wert holen }
  ror eax,16
  ror edx,16
  mov bl,dl;
  mov al,gs:[si+bx-1]; { 3. indizierten Wert holen }
  mov bl,dh;
  mov ah,gs:[si+bx-1]; { 4. indizierten Wert holen }
  ror eax,16
  xor eax,ss:[bp+di]; { komponentenweises XOR mit durch Displacement gegebener Tabelle }
  mov ss:[ebp+ecx],eax; { und in RES-Tabelle eintragen }
  sub bp,4;
  jae @@ResSchleife; { solange bp nichtnegativ -> Schleife ausfhren }
  pop bp;
  pop ds; { Datensegment zurckholen }
  ret
ENDP zauber386




END
