program TRDES;  { Version 0.9 }
{ Implementierung des DES-Kodierungsverfahrens }
{ by Thorsten Reinecke }
{$X+} { erweiterte Syntax einstellen }

uses inform, drives;

{ Umleitung der Ausgabe soll (zum Ausdrucken der Information)
  weiterhin mglich sein. Ich will aber trotzdem die folgenden Cursor-
  befehle verwenden knnen (wobei dann die Ausgabe auf Drucker
  natrlich schon sinnlos wre).
  Sowie ich diese Routinen ber eine selbstgeschriebene Unit einbinde,
  generiert der Compiler offenbar einen Code, der die Umleitung verhindert.
  Will gar nicht wissen, was da abgeht.
  Unit lohnt sich fr diese drei Routinen ja auch kaum, da man blicherweise
  eher die CRT-Unit einbinden wrde. }

procedure gotoxy (x,y : byte); assembler;
asm
 mov ah,2;
 mov bh,0;
 mov dl,x; mov dh,y;
 push bp; int $10; pop bp;
end;

function whereX : byte; assembler;
asm
 mov ah,3; mov bh,0;
 push bp; int $10; pop bp;
 mov al,dl;
end;

function whereY : byte; assembler;
asm
 mov ah,3; mov bh,0;
 push bp; int $10; pop bp;
 mov al,dh;
end;


const TRDESKennung : array[1..9] of char = 'TRDES 0.9'; { Prefix verschlsselter Files }

type ShortPointer = word; { enthlt nur den OFFSET-Teil der Adresse }
     Nibble = 0..15;
     tUserKey = array [0..7] of byte;
     tKey = array [1..64] of boolean;
     tBlock = array [1..64] of boolean;
     tLRBlock = array [1..32] of boolean;
     tEightBytes = array [1..8] of byte;

     tFileRec = record
                handle : word;
                Mode : word;
                RecSize : word;
                _Private : array [1..26] of byte;
                UserDate : array [1..16] of byte;
                Name : array [0..79] of char;
               end;

const UserKey : tUserKey = (0,0,0,0,0,0,0,0);  { hiermit wird verschlsselt }


procedure makeKey (UserKey : tUserKey; var k : tKey);
var i,j : byte;
begin
 for i:=0 to 7 do
  begin             { fr ungerade Paritt sorgen }
   j:=UserKey[i];
   asm cmp j,0; jpo @ok; xor j,$80; @ok: end;
   UserKey[i]:=j;
  end;
 for i:=0 to 7 do
  for j:=0 to 7 do
   begin
    k[8*i+succ(j)]:=(UserKey[i] and (1 shl j))>0;
   end;
{ for i:=1 to 64 do if k[i] then write('*') else write(' '); writeln;
 for i:=1 to 64 do write(i mod 8); writeln; }
end;


const
 perm : array [1..56] of byte = { Permutationsmatrix }
 ( 57, 49, 41, 33, 25, 17,  9,
    1, 58, 50, 42, 34, 26, 18,
   10,  2, 59, 51, 43, 35, 27,
   19, 11,  3, 60, 52, 44, 36,

   63, 55, 47, 39, 31, 23, 15,
    7, 62, 54, 46, 38, 30, 22,
   14,  6, 61, 53, 45, 37, 29,
   21, 13,  5, 28, 20, 12,  4 );


type tBlock28 = array [1..28] of boolean;

var c : array [0..16] of tBlock28;
    d : array [0..16] of tBlock28;


procedure shiftleft (var x : tBlock28);
var i : byte; w: boolean;
begin
 w:=x[1];
 for i:=1 to 27 do x[i]:=x[succ(i)];
 x[28]:=w;
end;


procedure create_cd_Blocks (Key : tKey);
var n,i : byte;
begin
 for i:=1 to 28 do c[0][i]:=Key[perm[i]];
 for i:=1 to 28 do d[0][i]:=Key[perm[28+i]];

 for n:=1 to 16 do
  begin
   c[n]:=c[n-1];
   d[n]:=d[n-1];
   case n of
    1,2,9,16 : shiftleft(c[n]);
    else       begin shiftleft(c[n]); shiftleft(c[n]); end;
   end;
  end;
end;


const perm2 : array [1..48] of byte =
 (  14, 17, 11, 24,  1,  5,
     3, 28, 15,  6, 21, 10,
    23, 19, 12,  4, 26,  8,
    16,  7, 27, 20, 13,  2,
    41, 52, 31, 37, 47, 55,
    30, 40, 51, 45, 33, 48,
    44, 49, 39, 56, 34, 53,
    46, 42, 50, 36, 29, 32 );

var k : array [1..16,1..48] of boolean;

procedure create_k;
var n,i : byte;
begin
 for n:=1 to 16 do
  for i:=1 to 48 do
   if perm2[i]>28 then k[n,i]:=d[n,perm2[i]-28] else k[n,i]:=c[n,perm2[i]];
end;




const z_expand : array [1..48] of byte =
 (32, 1, 2, 3, 4, 5,
   4, 5, 6, 7, 8, 9,
   8, 9,10,11,12,13,
  12,13,14,15,16,17,
  16,17,18,19,20,21,
  20,21,22,23,24,25,
  24,25,26,27,28,29,
  28,29,30,31,32, 1);
const z_S : array [1..8,0..3,0..15] of Nibble =
( ((14,4,13,1,2,15,11,8,3,10,6,12,5,9,0,7),  { S1 }
   (0,15,7,4,14,2,13,1,10,6,12,11,9,5,3,8),
   (4,1,14,8,13,6,2,11,15,12,9,7,3,10,5,0),
   (15,12,8,2,4,9,1,7,5,11,3,14,10,0,6,13)),

  ((15,1,8,14,6,11,3,4,9,7,2,13,12,0,5,10),  { S2 }
   (3,13,4,7,15,2,8,14,12,0,1,10,6,9,11,5),
   (0,14,7,11,10,4,13,1,5,8,12,6,9,3,2,15),
   (13,8,10,1,3,15,4,2,11,6,7,12,0,5,14,9)),

  ((10,0,9,14,6,3,15,5,1,13,12,7,11,4,2,8),  { S3 }
   (13,7,0,9,3,4,6,10,2,8,5,14,12,11,15,1),
   (13,6,4,9,8,15,3,0,11,1,2,12,5,10,14,7),
   (1,10,13,0,6,9,8,7,4,15,14,3,11,5,2,12)),

  ((7,13,14,3,0,6,9,10,1,2,8,5,11,12,4,15),  { S4 }
   (13,8,11,5,6,15,0,3,4,7,2,12,1,10,14,9),
   (10,6,9,0,12,11,7,13,15,1,3,14,5,2,8,4),
   (3,15,0,6,10,1,13,8,9,4,5,11,12,7,2,14)),

  ((2,12,4,1,7,10,11,6,8,5,3,15,13,0,14,9),  { S5 }
   (14,11,2,12,4,7,13,1,5,0,15,10,3,9,8,6),
   (4,2,1,11,10,13,7,8,15,9,12,5,6,3,0,14),
   (11,8,12,7,1,14,2,13,6,15,0,9,10,4,5,3)),

  ((12,1,10,15,9,2,6,8,0,13,3,4,14,7,5,11),  { S6 }
   (10,15,4,2,7,12,9,5,6,1,13,14,0,11,3,8),
   (9,14,15,5,2,8,12,3,7,0,4,10,1,13,11,6),
   (4,3,2,12,9,5,15,10,11,14,1,7,6,0,8,13)),

  ((4,11,2,14,15,0,8,13,3,12,9,7,5,10,6,1),  { S7 }
   (13,0,11,7,4,9,1,10,14,3,5,12,2,15,8,6),
   (1,4,11,13,12,3,7,14,10,15,6,8,0,5,9,2),
   (6,11,13,8,1,4,10,7,9,5,0,15,14,2,3,12)),

  ((13,2,8,4,6,15,11,1,10,9,3,14,5,0,12,7),  { S8 }
   (1,15,13,8,10,3,7,4,12,5,6,11,0,14,9,2),
   (7,11,4,1,9,12,14,2,0,6,10,13,15,3,5,8),
   (2,1,14,7,4,10,8,13,15,12,9,0,3,5,6,11)) );
const z_perm : array [1..32] of 1..32 =
 (16, 7,20,21,
  29,12,28,17,
   1,15,23,16,
   5,18,31,10,
   2, 8,24,14,
  32,27, 3, 9,
  19,13,30, 6,
  22,11, 4,25);


{$L trdes20.obj }
function detect_cpu : word; external; { liefert 8086, 286, 386 oder 486 zurck }

{ fr die 386er- und 486er-Prozessoren sind optimierte externe Routinen vorhanden: }
procedure zauber386 (LR : ShortPointer; n : byte;  RES : ShortPointer; XOR_Displacement : integer); external;
procedure zauber486 (LR : ShortPointer; n : byte;  RES : ShortPointer; XOR_Displacement : integer); external;


procedure zauber286 (LR : ShortPointer; n : byte; RES : ShortPointer; XOR_Displacement : integer); assembler;
{ LR und RES sind Offset-Adressen bezglich des SS-Segmentes,
  Das Ergebnis wird in der mit RES adressierten Tabelle abgelegt }
{ XOR_Displacement ist Displacement zu RES fr komponentenweise XOR-Verknpfung }
var B48 : array [1..48] of boolean;
    B : array [1..8,1..6] of boolean absolute B48;
    merk : tLRBlock;
asm
  push ds; { Datensegment merken }
  { for i:=1 to 48 do B48[i]:=LR[expand[i]] xor K[n][i]; }
  { dies wird nun realisiert }
  mov ax,SEG z_expand; mov ds,ax; { SEGMENT-Adresse der z_expand-Tabelle nach ds }
  { K (Key-Tabelle) z_S und z_perm liegen im gleichen Segment wie z_expand }
  mov al,n; dec al; { Zeilenadresse der Key-Tabelle }
  mov ah,48; mul ah; { mit Anzahl Spalten multiplizieren }
  mov cx,OFFSET K; add cx,ax; { OFFSET-Adresse der gewschten Teiltabelle von K nach cx }
  mov di,LR; { Adresse der LR-Tabelle ist ss:di }
  mov bx,cx; xor bl,bl; sub di,bx; { um die Registertauschoperationen zu
                                     minimieren, subtrahieren wir bh von di }
  push bp; lea bp,B48; { OFFSET der B48-Tabelle nach bp }
  mov si,48-2; { Schleifenindex-Zhler initialisiern (48 Elemente abwrts bis negativ)  }
 @Schleife1:
  mov dx,[ds:OFFSET z_expand][si]; { zwei Indices auf LR-Tabelle aus expand-Tabelle holen }
  { Index ist aber bzgl. 1-orientiertem Array, also um 1 zu hoch! }
  mov bl,dl; mov al,[ss:di][bx][-1]; { ersten Wert aus LR-Tabelle lesen }
  mov bl,dh; mov ah,[ss:di][bx][-1]; { zweiten Wert aus LR-Tabelle lesen }
  mov bx,cx; { Adresse der K[n]-Teiltabelle holen }
  xor ax,[ds:bx][si]; { und XOR mit Eintrag K[n][si+1] und K[n][si+2] aus dieser Tabelle }
  mov [ss:bp][si],ax; { und beide Werte (al,ah) in die B48-Tabelle eintragen }
  sub si,2; jae @Schleife1; { fertig, wenn si negativ }
  pop bp;

  lea si,B; { OFFSET-Adresse von B[1,1] }
  lea di,MERK; { OFFSET-Adresse von MERK }
  xor cx,cx; { cx =:64*pred(i) und i zhlt von 1. Zeile bis 8. Zeile }
 @MainLoop:
  { aus B[i,1..6] folgende 6-Bit-Zahl erzeugen:
     B[i,2],B[i,3],B[i,4],B[i,5],B[i,1],B[i,6] }
   {mov bh,[ss:si][2-1]; shr bx,1;}
   xor bx,bx;
   mov bh,[ss:si][3-1]; shr bx,1;
   mov bh,[ss:si][4-1]; shr bx,1;
   mov bh,[ss:si][5-1]; shr bx,1;
   mov bh,[ss:si][1-1]; shr bx,1;
   mov bh,[ss:si][6-1]; shr bx,3;
   or bl,[ss:si][2-1]; { nun steht der vollstndige 6-Bit-Wert in bx }
   add si,6; { Offset auf die nchste Zeile setzen }
   { in bx steht nun das Spaltendisplacement }
   add bx,cx; { Displacement fr Zeile addieren }
   mov al,[ds:OFFSET z_S][bx]; { Wert holen }
   { x=al:=S[i,x,y];} { dies ist der aktuelle Wert von x }
   { Adresse von Merk[4*pred(i)+1] steht in [ss:di] }
   { x in boolesche Binrdarstellung nach (Merk[4*(i-1)+1],..,Merk[4*(i-1)+4]) wandeln }
   mov ah,al; shr ah,1; { kopieren Wert um 1 geschifet nach ah }
   { Nun das Nibble in booleschen Wert konvertieren }
   mov bx,ax; and bx,$0101; { zwei boolesche Werte holen und maskieren }
   mov [ss:di],bx; add di,2; { wegpppeln, 2 am Stck }
   shr ax,2; { jetzt mssen wir dafr allerdings um 2 Bits shiften ;-) }
   and ax,$0101; { boolesche Werte maskieren }
   mov [ss:di],ax; add di,2; { und wegpppeln, 2 am Stck }
   add cx,64; cmp cx,7*64; jbe @mainloop;

  { for i:=1 to 32 do RES[i]:=MERK[z_perm[i]]; }
  mov di,RES; { Adresse der RES-Tabelle ist ss:di }
  lea si,merk; { OFFSET-Adresse der MERK-Tabelle holen, Segmantadresse ist immer noch in ds! }
  mov cx,XOR_Displacement; sar cx,4; mov ax,ss; add cx,ax; mov es,cx;
   { aus Offset-Displacement neues Segment zaubern, geht aber nur,
     weil Displacement Vielfaches von 32 ist }
  push bp; mov bp,32-2; { Index auf Null setzen, 32 Werte sind einzutragen }
  xor bh,bh; { Displacement Hi-Byte lschen }
 @ResSchleife:
  mov dx,[ds:OFFSET z_perm][bp]; { zwei z_Perm-Indices holen }
  { nicht vergessen: Array ist 1-orientiert [1..32], also 1 abziehen }
  mov bl,dl; mov al,[ss:si][bx][-1]; { 1. indizierten Wert holen }
  mov bl,dh; mov ah,[ss:si][bx][-1]; { 2. indizierten Wert holen }
  xor ax,[es:di][bp]; { XOR-Verknpfung }
  mov [ss:di][bp],ax; { und in RES-Tabelle eintragen }
  sub bp,2; jae @ResSchleife; { solange bp nichtnegativ -> Schleife ausfhren }
  pop bp;
  pop ds; { Datensegment zurckholen }
end;




const permblock : array [1..64] of byte =
( 58, 50, 42, 34, 26, 18, 10,  2,
  60, 52, 44, 36, 28, 20, 12,  4,
  62, 54, 46, 38, 30, 22, 14,  6,
  64, 56, 48, 40, 32, 24, 16,  8,
  57, 49, 41, 33, 25, 17,  9,  1,
  59, 51, 43, 35, 27, 19, 11,  3,
  61, 53, 45, 37, 29, 21, 13,  5,
  63, 55, 47, 39, 31, 23, 15,  7 );

procedure apply_initial_permutation (var Block : tBlock); assembler;
var Kopie : tBlock;
asm
  push ds;
  lds si,Block; lea di,Kopie; mov ax,ss; mov es,ax;
  mov cx,TYPE(tBlock)/2; rep movsw;
 { for i:=1 to 64 do Block[i]:=Kopie[permblock[i]]; }
  mov ax,SEG permblock; mov ds,ax; { SEGMENT-Adresse permblock nach ds }
  les di,Block; { Zieladresse ist es:di, die Adresse von Block }
  lea si,Kopie; { ss:si ist Adresse von Kopie }
  push bp; xor bp,bp; { bp ist Schleifenindex und wird mit 0 initialisiert }
  xor bh,bh; { Hi-Byte fr Displacement lschen }
 @Schleife:
  mov dx,[ds:OFFSET permblock][bp]; { zwei Displacements einlesen }
  { auch hier dann nicht vergesen, Array ist 1-orientiert }
  mov bl,dl; mov al,[ss:si][bx][-1]; { 1. Datum einlesen }
  mov bl,dh; mov ah,[ss:si][bx][-1]; { 2. Datum einlesen }
  mov [es:di][bp],ax; { und wegpppeln }
  add bp,2; cmp bp,TYPE(tBlock); jb @Schleife;
  pop bp;
  pop ds;
end;

procedure apply_inverse_initial_permutation (var Block : tBlock); assembler;
var Kopie : tBlock;
asm
  push ds;
  lds si,Block; lea di,Kopie; mov ax,ss; mov es,ax;
  mov cx,TYPE(tBlock)/2; rep movsw;
 { for i:=1 to 64 do Block[permblock[i]]:=Kopie[i]; }
  mov ax,SEG permblock; mov ds,ax; { SEGMENT-Adresse von permblock nach ds }
  les di,Block; { Zieladresse es:di ist Block-Adresse }
  push bp; lea bp,Kopie; { OFFSET-Adresse von Kopie nach bp }
  xor si,si; { si ist Schleifenindex }
  xor bh,bh; { Displacement-Hi-Byte lschen }
 @Schleife:
  mov ax,[ss:bp][si]; { zwei Werte einlesen }
  mov dx,[ds:OFFSET permblock][si]; { Displacements der zwei Werte holen }
  { Achtung: 1-orientertes Array, deshalb mit -1 auf Adresse normieren }
  mov bl,dl; mov [es:di][bx][-1],al; { 1.Wert in Tabelle eintragen }
  mov bl,dh; mov [es:di][bx][-1],ah; { 2.Wert in Tabelle eintragen }
  inc si; inc si; cmp si,TYPE(tBlock); jl @Schleife;
  pop bp;
  pop ds;
end;


function txt (a : array of char) : string;
var i : byte;
    s : string;
begin
 s:=''; i:=0;
 while a[i]<>#0 do begin s:=s+a[i]; inc(i); end;
 txt:=s;
end;


procedure byte8_to_bit64 (var x : tEightBytes; var w : tBlock); assembler;
{ 8-Byte-Array nach 64-Bit-Array-Boolean konvertieren: x -> w }
asm
  push ds;
  lds si,x; les di,w;
  mov cx,4;
 @byteloop:
  mov ax,[ds:si]; mov dx,ax;
  mov ah,al; shr ah,1;
  mov dl,dh; shr dh,1;
  mov bx,ax; and bx,$0101; shr ax,2; mov [es:di],bx; add di,2;
  mov bx,ax; and bx,$0101; shr ax,2; mov [es:di],bx; add di,2;
  mov bx,ax; and bx,$0101; shr ax,2; mov [es:di],bx; add di,2;
  and ax,$0101; mov [es:di],ax; add di,2;
  mov bx,dx; and bx,$0101; shr dx,2; mov [es:di],bx; add di,2;
  mov bx,dx; and bx,$0101; shr dx,2; mov [es:di],bx; add di,2;
  mov bx,dx; and bx,$0101; shr dx,2; mov [es:di],bx; add di,2;
  and dx,$0101; mov [es:di],dx; add di,2;
  add si,2; loop @byteloop;
  pop ds;
end;


procedure bit64_to_byte8 (var w : tBlock; var x : tEightBytes); assembler;
{ 64-Bit-Array Boolean nach 8-Byte-Array konvertieren: w -> x }
asm
  push ds;
  lds si,w; les di,x; { Adressen laden }
  add si,64; add di,8; { von "oben" anfangen }
  mov cx,4; { Schleifenzhler }
 @wordloop:
  mov bx,8;
 @bitloop:
  sub si,2; mov dx,[ds:si];
  shl ax,1; or al,dh; shl ax,1; or al,dl;
  dec bx; jnz @bitloop;
  sub di,2; mov [es:di],ax;
  loop @wordloop;
  pop ds;
end;




type tBuffer = array [1..8000] of tEightBytes;
{ Vorsicht, falls die Dateilnge nicht durch 8 Teilbar ist,
  mte man den letzten Block sicherheitshalber mit Zufallszahlen auffllen,
  um Angriffspunkte fr Entschlsselungen zu minimieren.
  Denn sonst werden die nicht berschriebenen Teildaten des
  am Schlu geschriebenen Blockes erneut verschlsselt }

const zauber : ShortPointer = OFS(zauber286);
{ hier wird die dem Prozessortyp entsprechend optimale Haupt-Verschlsselungs-
  routinen-Adresse eingetragen; Standard ist 80286 (ohne Protected-ModeBefehle
  also auch 80186-kompatibel); 8086/8088 werden hingegen nicht mehr
  untersttzt, Ausfhrungszeiten wren eh nicht akzeptabel ;-) }


const CBC_Block : tEightBytes = (0,0,0,0,0,0,0,0);
      { fr das CBC (CipherBlockChaining) Verfahren }

var next_CBC_Block : tEightBytes; { Zur Zwischenpufferung }

const CBC_Mode : BOOLEAN = FALSE; { Standard ist ECB-Verfahren }

procedure XOR_Block (var x1 : tEightBytes; x2 : tEightBytes); assembler;
{ x1 := x1 XOR x2 }
asm
 push ds;
 lds si,x1; les di,x2;
 mov bx,TYPE(tEightBytes)-2;
@Schleife:
 mov ax,[es:di][bx]; xor [ds:si][bx],ax;
 sub bx,2; jae @Schleife;
 pop ds;
end;


procedure encrypt_block (var x : tEightBytes);
var n : byte;
    Displacement : word;
    w : tBlock;
    R : array [-1..16] of tLRBlock;
    L : array [0..16] of tLRBlock absolute R;
begin
 byte8_to_bit64(x,w);
 apply_initial_permutation(w);
 move(w[1],L[0],32);
 move(w[33],R[0],32);
(*  for n:=1 to 16 do
   begin
    { L[n]:=R[n-1]; } { wegen der absolute-Deklaration unntig }
    zauber286(R[n-1],n,R[n]);
    LRBlock_xor(R[n],L[n-1]); { for i:=1 to 32 do R[n][i]:=L[n-1][i] xor R[n][i];}
   end;
  { ist quivalent mit folgendem Assemblerblock:
    Vorsicht: zauber erwartet ShortPointer, whrend der obere PascalBlock
              richtige Pointer bergibt! }
*)
 asm
  mov n,1; mov DISPLACEMENT,TYPE(tLRBlock);
 @Schleife:
  mov di,Displacement; lea ax,R+di; { R[n-1] }
  add di,TYPE(tLRBlock); lea bx,R+di; { R[n] }
  mov Displacement,di; { fr  nchsten Durchlauf speichern }
  push ax; push word(n); push bx; push -2*TYPE(tLRBlock);
  { dies waren die Parameter fr zauber }
  call [zauber]; { Routine aufrufen }
  inc n; cmp n,16; jbe @Schleife;
 end;
 move(R[16],w[1],32);
 move(L[16],w[33],32);
 apply_inverse_initial_permutation(w);
 bit64_to_byte8(w,x);
end;


procedure encrypt (var f,dest : file);
var x : ^tBuffer;
    res : word;
    i, obergrenze : word;
    fs,ap : longint; { FileSize, aktuelle Position, jeweils div 8 }
begin
 new(x); { Speicher fr Arbeitspuffer allokieren }
 reset(f,1); rewrite(dest,1);
 blockwrite(dest,TRDESKennung,SizeOf(TRDESKennung));
 i:=FileSize(f) mod 8; blockwrite(dest,i,1); { um korrekte Filelnge restaurienen zu knnen }
 fs:=FileSize(f) div 8; ap:=0;
 gotoxy(1,WhereY); write('  0.00% of ',txt(tFileRec(f).Name),' -> ',txt(tFileRec(dest).Name),' encrypted.');
 repeat
  blockread(f,x^,SizeOf(x^),res); { Blcke  64 Bits einlesen }
  obergrenze:=res shr 3; if (res and 7)<>0 then inc(obergrenze);
  for i:=1 to obergrenze do
   begin
    inc(ap); if lo(ap)=0 then
     begin gotoxy(1,WhereY); write(ap/fs*100:6:2); end;
    if CBC_Mode then
     begin { Cipher Block Chaining - Verfahren }
      XOR_Block(x^[i],CBC_Block);
      encrypt_block(x^[i]);
      move(x^[i],CBC_Block,SizeOf(CBC_Block))
     end
    else encrypt_block(x^[i]); { Electronic Code Book - Verfahren }
   end;
  blockwrite(dest,x^,obergrenze shl 3);
 until res<>SizeOf(x^);
 gotoxy(1,WhereY); writeln('100.00'); { Damit die 100% auch dastehen }
 dispose(x); { Speicher fr Arbeitspuffer freigeben }
end;


procedure decrypt_block (var x : tEightBytes);
var n : byte;
    Displacement : word;
    w : tBlock;
    R : array [-1..16] of tLRBlock;
    L : array [0..16] of tLRBlock absolute R;
begin
 byte8_to_bit64(x,w);
 apply_initial_permutation(w);
 move(w[1],R[16],32);
 move(w[33],L[16],32);
(*  for n:=16 downto 1 do
   begin
    { R[n-1]:=L[n]; } { wegen der absolute-Deklaration unntig }
    zauber286(L[n],n,L[n-1]);
    LRBlock_xor(L[n-1],R[n]); { for i:=1 to 32 do L[n-1][i]:=R[n][i] xor L[n-1][i]; }
   end;
  { ist quivalent mit folgendem Assemblerblock:
    Vorsicht: zauber erwartet ShortPointer, whrend der obere PascalBlock
              richtige Pointer bergibt! }
*)
 asm
  mov n,16; mov DISPLACEMENT,16*TYPE(tLRBlock);
 @Schleife:
  mov di,Displacement; lea ax,L+di; { L[n] }
  sub di,TYPE(tLRBlock); lea bx,L+di; { L[n-1] }
  mov Displacement,di; { fr  nchsten Durchlauf speichern }
  push ax; push word(n); push bx; push 2*TYPE(tLRBlock);
                                   { dies waren die Parameter fr zauber }
  call [zauber]; { Routine aufrufen }
  dec n; jnz @Schleife;
 end;
 move(L[0],w[1],32);
 move(R[0],w[33],32);
 apply_inverse_initial_permutation(w);
 bit64_to_byte8(w,x);
end;

procedure decrypt (var f,dest : file);
var x : ^tBuffer;
    res : word;
    i, obergrenze : word;
    fisimod8 : byte; { FileSize des Originals mod 8 }
    test : array [1..SizeOf(TRDESKennung)] of Char;
    fs,ap : longint; { FileSize, aktuelle Position, jeweils div 8 }
begin
 new(x); { Speicher fr Arbeitspuffer allokieren }
 reset(f,1);
 blockread(f,Test,SizeOf(TRDESKennung));
 if Test<>TRDESKennung then begin write('Not a correct',TRDESKennung,'-File!'); halt(1); end;
 blockread(f,fisimod8,1); { um korrekte Filelnge restaurienen zu knnen }
 rewrite(dest,1);
 fs:=(FileSize(f)-SizeOf(TRDESKennung)-1) div 8; ap:=0;
 gotoxy(1,WhereY); write('  0.00% of ',txt(tFileRec(f).Name),' -> ',txt(tFileRec(dest).Name),' decrypted.');
 repeat
  blockread(f,x^,SizeOf(x^),res); { Blcke  64 Bits einlesen }
  obergrenze:=res shr 3; if (res and 7)<>0 then inc(obergrenze);
  for i:=1 to obergrenze do
   begin
    inc(ap); if lo(ap)=0 then
    begin gotoxy(1,WhereY); write(ap/fs*100:6:2); end;
    if CBC_Mode then { Cipher Block Chaining - Verfahren }
     begin
      move(x^[i],next_CBC_Block,SizeOf(CBC_Block));
      decrypt_block(x^[i]);
      XOR_Block(x^[i],CBC_Block);
      move(next_CBC_Block,CBC_Block,SizeOf(CBC_Block));
     end
    else decrypt_block(x^[i]); { Electronic Code Book - Verfahren }
   end;
  blockwrite(dest,x^,obergrenze shl 3);
 until res<>SizeOf(x^);
 if fisimod8>0 then
  begin
   fisimod8:=8-fisimod8;
   seek(dest,FilePos(dest)-fisimod8);
   truncate(dest); { an dieser Position ist das Originalende }
  end;
 gotoxy(1,WhereY); writeln('100.00'); { Damit die 100% auch dastehen }
 dispose(x); { Speicher fr Arbeitspuffer freigeben }
end;

procedure encrypt_drive (drive : char);
var x : ^tBuffer;
    akt_sector, highest_sector : longint;
    DESblocks_per_sector : word;
    sectors_per_buffer : word;
    i : word;
label nooutputupdate;
begin
 new(x); { Speicher fr Arbeitspuffer allokieren }
 gotoxy(1,WhereY); write('  0.00% of ',drive,' encrypted.');
 sectors_per_buffer:=SizeOf(tBuffer) div Sectorsize(drive); { Gre ermitteln }
 DESblocks_per_sector:=SectorSize(drive) div SizeOf(tEightBytes); { Anzahl der zu bearbeitenden Blcke pro Vorgang }
 highest_sector:=totalSectors(drive)-1;
 akt_Sector:=1; { Zhlung beginnt zwar bei 0, aber 0.Sektor enthlt fr DOS
                  wichtige Daten, so da bei Verschlsselung nur BIOS-Zugriff
                  zur Entschlsselung mglich wre, und dies will ich
                  zunchst noch nicht (wegen fehlendem einheitlichem Zugriff
                  auf verschiedensten Datentrger). }
 while akt_Sector<=highest_sector do
  begin
   if akt_Sector+Sectors_per_Buffer>highest_sector
    then Sectors_per_Buffer:=highest_Sector-akt_Sector+1;
   SectorRead(drive,akt_sector,Sectors_per_Buffer,x^);
   for i:=1 to Sectors_per_Buffer*DESBlocks_per_Sector do
    begin
     asm mov ax,i; test al,al; jnz nooutputupdate; end;
     gotoxy(1,WhereY);
     write((akt_sector+(i/DESBlocks_per_Sector))/highest_Sector*100:6:2); { Wie weit sind wir? }
    nooutputupdate:
     if CBC_Mode then
      begin { Cipher Block Chaining - Verfahren }
       XOR_Block(x^[i],CBC_Block);
       encrypt_block(x^[i]);
       move(x^[i],CBC_Block,SizeOf(CBC_Block))
      end
     else encrypt_block(x^[i]); { Electronic Code Book - Verfahren }
    end;
   SectorWrite(drive,akt_sector,Sectors_per_Buffer,x^);
   inc(akt_Sector,Sectors_per_Buffer);
  end;
 gotoxy(1,WhereY); writeln('100.00'); { Damit die 100% auch dastehen }
 dispose(x); { Speicher fr Arbeitspuffer freigeben }
end;

procedure decrypt_drive (drive : char);
var x : ^tBuffer;
    akt_sector, highest_sector : longint;
    DESblocks_per_sector : word;
    sectors_per_buffer : word;
    i : word;
label nooutputupdate;
begin
 new(x); { Speicher fr Arbeitspuffer allokieren }
 gotoxy(1,WhereY); write('  0.00% of ',drive,' decrypted.');
 sectors_per_buffer:=SizeOf(tBuffer) div Sectorsize(drive); { Gre ermitteln }
 DESblocks_per_sector:=SectorSize(drive) div SizeOf(tEightBytes); { Anzahl der zu bearbeitenden Blcke pro Vorgang }
 highest_sector:=totalSectors(drive)-1;
 akt_Sector:=1; { Erster Sektor ist zwar 0, aber wegen erforderlicher Daten
                  zum logischen Laufwerk fr DOS konnte dieser nicht verschlsselt
                  werden, sonst htte sich diese Routine nmlich nur auf
                  bekannte physikalische Laufwerke beschrnkt }
 while akt_Sector<=highest_sector do
  begin
   if akt_Sector+Sectors_per_Buffer>highest_sector
    then Sectors_per_Buffer:=highest_Sector-akt_Sector+1;
   SectorRead(drive,akt_sector,Sectors_per_Buffer,x^);
   for i:=1 to Sectors_per_Buffer*DESBlocks_per_Sector do
    begin
     asm mov ax,i; test al,al; jnz nooutputupdate; end;
     gotoxy(1,WhereY);
     write((akt_sector+(i/DESBlocks_per_Sector))/highest_Sector*100:6:2); { Wie weit sind wir? }
    nooutputupdate:
     if CBC_Mode then { Cipher Block Chaining - Verfahren }
      begin
       move(x^[i],next_CBC_Block,SizeOf(CBC_Block));
       decrypt_block(x^[i]);
       XOR_Block(x^[i],CBC_Block);
       move(next_CBC_Block,CBC_Block,SizeOf(CBC_Block));
      end
     else decrypt_block(x^[i]); { Electronic Code Book - Verfahren }
    end;
   SectorWrite(drive,akt_sector,Sectors_per_Buffer,x^);
   inc(akt_Sector,Sectors_per_Buffer);
  end;
 gotoxy(1,WhereY); writeln('100.00'); { Damit die 100% auch dastehen }
 dispose(x); { Speicher fr Arbeitspuffer freigeben }
end;


procedure create_UserKey (s : string; var uk : array of byte);
var i,j : byte;
begin
 i:=0;
 for j:=LOW(uk) to HIGH(uk) do { von unterer Array-Grenze bis obere Array-Grenze }
  begin
   if i<length(s) then inc(i) else break;
   UK[j]:=ord(s[i]) and 15;
   if i<length(s) then inc(i) else break;
   UK[j]:=UK[j] or ((ord(s[i]) and 15) shl 4);
  end;
 writeln(4*i,' bits.'); { Bitlnge des Schlssels }
end;


procedure stopit;
begin
 writeln;
 writeln('Usage:');
 writeln('TRDES <command> [<-sw>...<-sw>] [<sourcefile> <destinationfile>]');
 writeln('commands:');
 writeln(' e : encrypt (verschlsseln) | d : decrypt (entschlsseln) | i : Information');
 writeln('switches:');
 writeln(' -k:<key> : use <key> as keyword (up to 16 letters)');
 writeln(' -286     : use 80186/80286 Code');
 writeln(' -386     : use 80386 Code');
 writeln(' -486     : use 80486 Code');
 writeln(' -cbc     : use Cipher Block Chaining without a second key');
 writeln(' -cbc:<key> : use CBC with given key as first block');
 writeln(' -drive:<DriveLetter> : encrypt/decrypt whole drive (be carefull!)');
 writeln;
 writeln(' if no -k switch given: you are asked for key');
 writeln(' if no CPU switch given: program autodectects CPU');
 writeln;
 writeln('You may copy or distribute TRDES free of charge. You may use TRDES at your own');
 writeln('risk. The author disclaims any warranty. For further information call author.');
 halt(1);
end;



var Key : tKey;
    bef : char; { Kommandozeilen-Befehl }
    s, param : string;
    source, dest : file;
    i, anzpar : byte;
const sourcename : string[79] = '';
const destinationname : string[79] = '';
const drive : char = #0; { #0: kein Laufwerk gewhlt }
const cpu : word = 0; { detected CPU-Type }
begin
 writeln(TRDESKennung,' - Data Encryption & Decryption');
 writeln('(C)1994 by Thorsten Reinecke, Buchenweg 14, 31559 Haste, GERMANY');

 anzpar:=paramcount;
 s:=ParamStr(1);
 if (s='/?') or (s='-?') or (s='?') or (s='i') then
  begin { Anwender-Informationen ausgeben }
   some_information; stopit;
  end;
 if s[0]=#1 then bef:=s[1] else stopit;
 if not (bef in ['e','d']) then stopit;

 s:=''; { string lschen }

 { Switches einlesen und setzen }
 for i:=2 to anzpar do
  begin
   param:=ParamStr(i);
   if copy(param,1,3)='-k:' then s:=copy(param,4,length(param)-3) else
   if param='-286' then cpu:=286 else
   if param='-386' then cpu:=386 else
   if param='-486' then cpu:=486 else
   if param='-cbc' then CBC_Mode:=TRUE { CBC-Modus ein; erster CBC-Block bleibt programmgegeben }
   else
   if copy(param,1,5)='-cbc:' then
    begin
     CBC_Mode:=TRUE; { CBC-Modus aktivieren }
     write('CBC-Key: ');
     create_UserKey(copy(param,6,length(param)-5),CBC_Block); { erster CBC-Block ist anwendergegeben }
    end else
   if (copy(param,1,7)='-drive:') and (length(Param)=8)
    then drive:=Upcase(Param[8]) else
   if (param[1]<>'-') then
    begin
     if sourcename='' then sourcename:=param else
      if destinationname='' then destinationname:=param
       else begin writeln('invalide parameter: ',param); stopit; end;
    end else
   begin writeln('invalide parameter: ',param); stopit; end;
  end;
 if (drive=#0) and (destinationname='') then
  begin writeln('error: missing filenames'); stopit; end;
 { Prozessor-spezifische Routinen setzen }
 if cpu=0 then
  begin { wenn cpu immer noch auf Null steht, dann autodetect Procezzor }
   cpu:=detect_cpu; writeln('80',cpu,'-Processor detected.');
  end;
 if cpu<186 then begin writeln('This CPU is not supported.'); stopit; end
 else
  case cpu of
   386 : zauber:=Ofs(zauber386); { 386-Routine benutzen }
   486 : zauber:=Ofs(zauber486); { 486-Routine benutzen }
  end; { alles andere benutzt die 286er Routine, falls Programm nicht schon abgebrochen }

  { Key einlesen, falls nicht per switch gesetzt }
  if s='' then
   begin
    fastwrite('Please input key: '); readln(s);
   end;
  write('DES-Key: ');
  create_UserKey(s,UserKey); { mache aus dem Buchstaben-Schlssel einen 8-Byte-Schlssel }

  if CBC_Mode then writeln('Mode: CBC (Cipher Block Chaining)')
              else writeln('Mode: ECB (Electronic Code Book)');

 { falls Ausgabe umgelenkt wurde, geht sie jetzt auf jeden Fall zum Screen }
 flush(output);
 asm mov ah,$46; mov bx,2; mov cx,1; int $21; end; { redirect handle }
 rewrite(output);

 { Verschlsselungkode initialisieren und "loslegen" }
 makekey(UserKey,key);
 create_cd_Blocks(Key);
 create_k;
 if drive=#0 then
  begin { Dateien werden ver-/entschlsselt }
   assign(source,sourcename);
   assign(dest,destinationname);
   case bef of
    'e': encrypt(source,dest); { verschlsseln }
    'd': decrypt(source,dest); { entschlsseln }
    else stopit; { ungltiger Befehl }
   end;
   close(source);
   close(dest);
  end
 else
  begin { Laufwerk wird ver-/entschlsselt }
   writeln('Warning: Drive encryption/decryption on Drive ',drive,' !');
   if totalSectors(Drive)=0 then
    begin
     writeln('Error: Unable to access Drive',drive); halt(1);
    end;
   if SectorSize(drive) mod 8<>0 then
    begin
     writeln('Error: Sectorsize is not fitting.',drive); halt(1);
    end;
   writeln('Size of ',drive,' is about ',Megabytes(drive),' MB.');
   if Megabytes(drive)>2 then writeln('Encryption/Decryption may take a long time!');
   writeln('Loss of all Data is possible, if');
   writeln(' - Program has BUGS');
   writeln(' - Program is interrupted while coding data');
   writeln(' - you forget your KEYWORD(S)');
   writeln('Do you want do continue? Type "Yes" or something else if not.');
   write('Your answer: '); s:=''; readln(s); if s<>'Yes' then halt;
   case bef of
    'e': encrypt_drive(drive); { verschlsseln }
    'd': decrypt_drive(drive); { entschlsseln }
    else stopit; { ungltiger Befehl }
   end;
  end;
end.